import 'package:flutter/material.dart';
import 'package:flutter/widgets.dart';
import 'package:share/share.dart';

import 'drawer.dart';

class ExcusePage extends StatefulWidget {
  ExcusePage({
    Key key,
  }) : super(key: key);

  @override
  _ExcusePageState createState() => _ExcusePageState();
}

class _ExcusePageState extends State<ExcusePage> {
  static DateTime selectedDate = DateTime.now();
  static TimeOfDay selectedTime = TimeOfDay.now();

  String _PDFText = "";
  String datenow = DateTime.now().day.toString() +
      "." +
      DateTime.now().month.toString() +
      "." +
      DateTime.now().year.toString();

  static String foaValue = "Mrs.",
      childValue = "Son",
      date = selectedDate.day.toString() +
          "." +
          selectedDate.month.toString() +
          "." +
          selectedDate.year.toString(),
      timeOfLeave =
          selectedTime.hour.toString() + ":" + selectedTime.minute.toString(),
      timeOfStart =
          selectedTime.hour.toString() + ":" + selectedTime.minute.toString();

  String fOA = "Mrs.";
  String nOT = "";
  String nOP = "";
  String dOS = date;
  String tOS = timeOfStart;
  String tOL = timeOfLeave;
  String cG = "Son";
  String nOC = "";
  String cls = "";
  String pOR = "";
  String ePS = "";
  String cSP = "";

  Future<Null> _selectDate(BuildContext context) async {
    final DateTime picked = await showDatePicker(
        context: context,
        initialDate: selectedDate,
        firstDate: DateTime(2015, 8),
        lastDate: DateTime(2101));
    if (picked != null && picked != selectedDate)
      setState(() {
        selectedDate = picked;
        date = selectedDate.day.toString() +
            "." +
            selectedDate.month.toString() +
            "." +
            selectedDate.year.toString();

        dOS = date;
      });
  }

  Future<Null> _selectTime(BuildContext context, bool tOfLeave) async {
    final TimeOfDay picked =
        await showTimePicker(context: context, initialTime: selectedTime);

    if (picked != null && picked != selectedTime)
      setState(() {
        selectedTime = picked;
        if (tOfLeave) {
          timeOfLeave = selectedTime.hour.toString() +
              ":" +
              selectedTime.minute.toString();
          tOL = timeOfLeave;
        } else {
          timeOfStart = selectedTime.hour.toString() +
              ":" +
              selectedTime.minute.toString();
          tOS = timeOfStart;
        }
      });
  }

  void createPDF() {
    setState(() {
      _PDFText =
          "\\documentclass{article}\n\\usepackage[utf8]{inputenc}\n\\usepackage{amsmath}\n\\usepackage{amstext}\n\n\\title{\\Huge Beurlaubung}\n\n\\begin{document}\n\\maketitle\n\nSehr geehrte Frau $nOT,\\newline\\newline hiermit beantrage ich, meine Tochter $nOC, Klasse $cls, am $dOS ab $tOL Uhr zu beurlauben.\\newline\\newline Sie wird an diesem Tag nicht am Unterricht teilnehmen, sondern auf eine Demonstration für eine lebensrettende Klimapolitik gehen. Am $dOS ab $tOS findet in $cSP, $ePS, eine Demonstration von Schüler*innen für eine lebensrettende Klimapolitik unter dem Motto #FridaysForFuture statt.\\newline\\newline Nach dem Vorbild von und in Solidarität mit Greta Thunberg, die jeden Freitag vor dem schwedischen Parlament streikt, ist die Bewegung inzwischen auf der ganzen Welt vertreten.\\newline\\newline Der Klimawandel ist längst eine reale Bedrohung für unsere Zukunft. Unsere Kinder werden die ersten Leidtragenden des Klimawandels sein. Gleichzeitig sind wir die letzte Generation, die einen katastrophalen Klimawandel noch verhindern kann. Doch unsere Politiker*innen unternehmen nichts, um die Klimakrise abzuwenden.\\newline\\newline Die Treibhausgas-Emissionen steigen seit Jahren und noch immer werden Kohle, Öl und Gas abgebaut und verbrannt. Deswegen geht mein Kind freitags nicht in die Schule. Denn mit jedem Tag, der ungenutzt verstreicht, wird ihre Zukunft aufs Spiel gesetzt!\\newline\\newline #FridaysForFuture ist weder an eine Partei noch an eine Organisation gebunden. Die Klimastreik-Bewegung hat ihre eigene Dynamik und wird durch hunderte individuelle junge Menschen getragen, die freitags streiken, eine Website aufbauen, Pressemitteilungen schreiben, Reden halten, Lautsprecher organisieren und vieles mehr.\\newline\\newline Die Bewegung hat im Vorfeld schon viel Unterstützung erfahren, ist allerdings auch oft auf Ablehnung gestoßen, meist aufgrund von Unsicherheit und der Angst vor negativen Konsequenzen.\\newline\\newline Mit diesem Antrag möchte ich klarstellen, dass ich mich mit der rechtlichen Grundlage von Schülerstreiks sorgfältig auseinandergesetzt habe:\\newline\\newline In Artikel 20a des Grundgesetzes ist festgehalten, dass der Staat die natürlichen Lebensgrundlagen schützt und Verantwortung für die künftigen Generationen trägt.\\newline\\newline Dieser Pflicht den künftigen Generationen gegenüber kommt der Staat allerdings nicht nach, weshalb für uns gilt: Wir streiken, bis ihr handelt!\\newline\\newline Wir berufen uns bei unserem Streik vor allem auf unser Recht auf Demonstrationsfreiheit, welches jedem Menschen in Deutschland zusteht (GG, Art. 8). Außerdem ist in der allgemeinen\\newline\\newline Schulordnung die Meinungsfreiheit aller Schüler*innen festgehalten (AschO, § 36).\\newline\\newline Da die Demonstration eine vom Grundgesetz geschützte Form der Meinungsäußerung ist, die allen Schüler*innen zusteht (GG, Art. 8), und sich der Streik außerdem für eine Politik stark macht, welche unser aller Überleben auf diesem Planeten sichert, kann mein Kind den staatlichen Bildungsauftrag dort am dOS besser wahrnehmen, als in der Schule selbst. Ich nehme zur Kenntnis, dass es sich bei der Demonstration nicht um eine Schulveranstaltung handelt und die Lehrer*innen keine Aufsichtspflicht haben. Der Veranstalter stellt für die Dauer der Versammlung volljährige Ordner*innen.\\newline\\newline Ich bitte darum, unter diesen besonderen Umständen von einer Eintragung unentschuldigter Fehlstunden abzusehen.\\newline\\newline Mit freundlichen Grüßen,\\newline\\newline $nOP\\newline\\newline $pOR, den $datenow \\newline\\newline\\newline ------------------------------- \\newline\\newline Unterschrift der/des Erziehungsberechtigten\n\n\\end{document}";
    });
  }

  @override
  Widget build(BuildContext context) {
    // This method is rerun every time setState is called, for instance as done
    // by the _incrementCounter method above.
    //
    // The Flutter framework has been optimized to make rerunning build methods
    // fast, so that you can just rebuild anything that needs updating rather
    // than having to individually change instances of widgets.

    final key = new GlobalKey<ScaffoldState>();

    return Scaffold(
        drawer: ClimateDrawer(),
        appBar: AppBar(
          // Here we take the value from the MyHomePage object that was created by
          // the App.build method, and use it to set our appbar title.
          title: Text("Excuse Generator"),
        ),
        body: Center(
            child: ListView(
                shrinkWrap: true,
                padding: EdgeInsets.all(15.0),
                children: <Widget>[
              Center(
                  child: Card(
                      elevation: 8.0,
                      child: Container(
                          padding: EdgeInsets.all(10.0),
                          child: Column(children: <Widget>[
                            Text(
                              "Automatic Excuse Generator",
                              style: Theme.of(context).textTheme.display1,
                            ),
                            DropdownButton<String>(
                              value: foaValue,
                              onChanged: (String newValue) {
                                setState(() {
                                  foaValue = newValue;
                                  fOA = foaValue;
                                });
                              },
                              items: <String>[
                                'Mrs.',
                                'Mr.'
                              ].map<DropdownMenuItem<String>>((String value) {
                                return DropdownMenuItem<String>(
                                  value: value,
                                  child: Text(value),
                                );
                              }).toList(),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            TextField(
                              onChanged: (String newVal) {
                                setState(() {
                                  nOT = newVal;
                                });
                              },
                              decoration: InputDecoration(
                                  hintText: 'Name of the teacher / principal'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            TextField(
                              onChanged: (String newVal) {
                                setState(() {
                                  nOP = newVal;
                                });
                              },
                              decoration: InputDecoration(
                                  hintText: 'Name of the parent'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            Text("$date"),
                            SizedBox(
                              height: 5.0,
                            ),
                            RaisedButton(
                              onPressed: () => _selectDate(context),
                              child: Text('Select date of the strike'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            Text("$timeOfLeave"),
                            SizedBox(
                              height: 5.0,
                            ),
                            RaisedButton(
                              onPressed: () => _selectTime(context, true),
                              child: Text('Select time of leave'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            Text("$timeOfStart"),
                            SizedBox(
                              height: 5.0,
                            ),
                            RaisedButton(
                              onPressed: () => _selectTime(context, false),
                              child: Text(
                                  'Select time of the beginning of the strike'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            DropdownButton<String>(
                              value: childValue,
                              onChanged: (String newValue) {
                                setState(() {
                                  childValue = newValue;
                                  cG = childValue;
                                });
                              },
                              items: <String>[
                                'Son',
                                'Daughter'
                              ].map<DropdownMenuItem<String>>((String value) {
                                return DropdownMenuItem<String>(
                                  value: value,
                                  child: Text(value),
                                );
                              }).toList(),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            TextField(
                              onChanged: (String newVal) {
                                setState(() {
                                  nOC = newVal;
                                });
                              },
                              decoration: InputDecoration(
                                  hintText: 'Name of the child'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            TextField(
                              onChanged: (String newVal) {
                                setState(() {
                                  cls = newVal;
                                });
                              },
                              decoration: InputDecoration(hintText: 'Class'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            TextField(
                              onChanged: (String newVal) {
                                setState(() {
                                  pOR = newVal;
                                });
                              },
                              decoration: InputDecoration(
                                  hintText: 'Place of residence'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            TextField(
                              onChanged: (String newVal) {
                                setState(() {
                                  ePS = newVal;
                                });
                              },
                              decoration: InputDecoration(
                                  hintText: 'Exact place of the strike'),
                            ),
                            SizedBox(
                              height: 20.0,
                            ),
                            TextField(
                              onChanged: (String newVal) {
                                setState(() {
                                  cSP = newVal;
                                });
                              },
                              decoration: InputDecoration(
                                  hintText:
                                      'City where the strike takes place'),
                            ),
                            Padding(
                              padding: const EdgeInsets.all(8.0),
                              child: RaisedButton(
                                onPressed: () => createPDF(),
                                child: Text("Generate excuse!"),
                              ),
                            ),
                            Tooltip(
                                message: 'Tap to share',
                                child: SelectableText(
                                  _PDFText,
                                  onTap: () {
                                    Share.share(_PDFText);
                                  },
                                )),
                          ]))))
            ])));
  }
}
